﻿using UnityEngine;
using HarmonyLib;
using System.Collections.Generic;
using System.IO;
using System;
using UnityEngine.UI;

public class StackablePlaceables : Mod
{
    private Harmony harmony;
    static string configPath = Path.Combine(SaveAndLoad.WorldPath, "StackablePlaceables.json");
    public static JSONObject Config = getSaveJson();
    public static bool overrideAccept = false;
    private static bool _oR = false;
    private static bool _oS = true;
    public static GameObject imageContainer;
    public static timeDiff control;
    public static string togglePopupKey;
    public static bool pToggle;
    public static bool popupToggled;
    public static bool overrideRayhit
    {
        get
        {
            return _oR;
        }
        set
        {
            _oR = value;
            if (!value)
                Patch_raycast.ResetPositions();
        }
    }
    public static bool fullOverride
    {
        get
        {
            if (Config.IsNull || !Config.HasField("fullSupport"))
                return false;
            return Config.GetField("fullSupport").b;
        }
        set
        {
            if (!Config.IsNull && Config.HasField("fullSupport"))
                Config.SetField("fullSupport", value);
            else
                Config.AddField("fullSupport", value);
            saveJson(Config);
        }
    }
    public static bool overrideSupport
    {
        get
        {
            if (Config.IsNull || !Config.HasField("overrideSupport"))
                return false;
            return Config.GetField("overrideSupport").b;
        }
        set
        {
            if (!Config.IsNull && Config.HasField("overrideSupport"))
                Config.SetField("overrideSupport", value);
            else
                Config.AddField("overrideSupport", value);
            saveJson(Config);
            if (!value && !_oR)
                Patch_raycast.ResetPositions();
        }
    }
    public static bool showTips
    {
        get
        {
            if (popupToggled)
                return false;
            Network_Player player = RAPI.GetLocalPlayer();
            return player != null && player.Inventory.GetSelectedHotbarItem() != null && (player.Inventory.GetSelectedHotbarItem().UniqueName == "Hammer" || (player.Inventory.GetSelectedHotbarItem().settings_buildable != null && player.Inventory.GetSelectedHotbarItem().settings_buildable.HasBuildablePrefabs));
        }
    }
    public static bool togglePopsKey
    {
        get
        {
            if (ExtraSettingsAPI_Loaded)
                return MyInput.GetButton(togglePopupKey);
            return Input.GetKey(KeyCode.H);
        }
    }
    public static Vector3 rotation = Vector3.zero;
    static public JsonModInfo modInfo;
    public static Settings settingsController = ComponentManager<Settings>.Value;
    static Traverse settingsTraverse = Traverse.Create(settingsController);
    static GameObject OptionMenuContainer = settingsTraverse.Field("optionsCanvas").GetValue<GameObject>().transform.FindChildRecursively("OptionMenuParent").gameObject;
    static Text display;
    static CanvasHelper _can = null;
    public static CanvasHelper canvas
    {
        get
        {
            if (_can == null)
                _can = ComponentManager<CanvasHelper>.Value;
            return _can;
        }
    }
    public void Start()
    {
        modInfo = modlistEntry.jsonmodinfo;
        harmony = new Harmony("com.aidanamite.StackablePlaceables");
        harmony.PatchAll();
        control = new timeDiff(0.3, true, true);
        if (RAPI.GetLocalPlayer() != null)
            AddImageObject(canvas.transform, 0);
        // string str = "";foreach (AssetBundle asset in AssetBundle.GetAllLoadedAssetBundles()) foreach (string name in asset.GetAllAssetNames()) str += "\n" + name;Debug.Log(str);

        Log("Mod has been loaded!");
    }
    public override void WorldEvent_WorldLoaded()
    {
        AddImageObject(canvas.transform, 0);
    }
    public override void WorldEvent_WorldUnloaded()
    {
        if (imageContainer != null)
        {
            Destroy(imageContainer);
            imageContainer = null;
        }
    }

    [ConsoleCommand(name: "toggleForceAccept", docs: "When active, ignores most build location restrictions")]
    public static string MyCommand(string[] args)
    {
        overrideAccept = !overrideAccept;
        return "[" + modInfo.name + "]: Is " + (overrideAccept ? "now" : "no longer") + " overriding acceptable build location";
    }

    [ConsoleCommand(name: "toggleOverrideRaycast", docs: "When active, uses alternate placement location finder")]
    public static string MyCommand2(string[] args)
    {
        overrideRayhit = !overrideRayhit;
        return "[" + modInfo.name + "]: Is " + (overrideRayhit ? "now" : "no longer") + " overriding build location raycast";
    }

    [ConsoleCommand(name: "toggleNoSupport", docs: "When active, allows certain blocks to be placed without support")]
    public static string MyCommand3(string[] args)
    {
        overrideSupport = !overrideSupport;
        return "[" + modInfo.name + "]: Is " + (overrideSupport ? "now" : "no longer") + " overriding support requirements";
    }

    [ConsoleCommand(name: "toggleFullSupport", docs: "When active, extends the No Support Override to affect ALL blocks")]
    public static string MyCommand4(string[] args)
    {
        fullOverride = !fullOverride;
        return "[" + modInfo.name + "]: Is " + (fullOverride ? "now" : "no longer") + " overriding all support requirements";
    }

    [ConsoleCommand(name: "setBuildRotations", docs: "Syntax: setBuildRotations <xRot> <zRot> - Recommended to use multiples of 90")]
    public static string MyCommand5(string[] args)
    {
        if (args.Length < 2)
            return "Not enough arguments";
        if (args.Length > 2)
            return "Too many arguments";
        float x;
        try
        {
            x = float.Parse(args[0]);
        } catch
        {
            return "[" + modInfo.name + "]: " + args[0] + " cannot be parsed";
        }
        try
        {
            rotation = new Vector3(x,0,float.Parse(args[1]));
            return "[" + modInfo.name + "]: Rotations modified";
        }
        catch
        {
            return "[" + modInfo.name + "]: " + args[1] + " cannot be parsed";
        }
    }

    public static void Log(object message)
    {
        Debug.Log("[" + modInfo.name + "]: " + message.ToString());
    }

    public void Update()
    {
        if (MyInput.GetButton("Rotate")) //Input.GetKey(MyInput.Keybinds["Rotate"].MainKey))
        {
            //Log("Holding R");
            if (Input.GetKeyDown(KeyCode.LeftArrow))
                rotation.x += 90;
            if (Input.GetKeyDown(KeyCode.RightArrow))
                rotation.x -= 90;
            if (Input.GetKeyDown(KeyCode.UpArrow))
                rotation.z += 90;
            if (Input.GetKeyDown(KeyCode.DownArrow))
                rotation.z -= 90;
            if (Input.GetKeyDown(KeyCode.LeftAlt) || Input.GetKeyDown(KeyCode.RightAlt))
                rotation = Vector3.zero;
            rotation.x %= 360;
            rotation.z %= 360;
        }
        if (MyInput.GetButton("Sprint"))
        {
            //Log("Holding S");
            if (Input.GetKeyDown(KeyCode.LeftArrow))
                overrideRayhit = true;
            if (Input.GetKeyDown(KeyCode.RightArrow))
                overrideRayhit = false;
            if (Input.GetKeyDown(KeyCode.UpArrow))
                overrideAccept = true;
            if (Input.GetKeyDown(KeyCode.DownArrow))
                overrideAccept = false;
            if (Input.GetKeyDown(KeyCode.LeftAlt) || Input.GetKeyDown(KeyCode.RightAlt))
            {
                overrideRayhit = false;
                overrideAccept = false;
            }
        }
        if (imageContainer != null)
        {
            if (pToggle != togglePopsKey)
            {
                pToggle = !pToggle;
                if (pToggle)
                    popupToggled = !popupToggled;
            }
            RectTransform trans = imageContainer.GetComponent<Image>().rectTransform;
            float newValue = control.Update(!showTips);
            trans.anchorMin = new Vector2(0.8f + newValue * 0.2f, 0.3f);
            trans.anchorMax = new Vector2(1f + newValue * 0.2f, 0.7f);
            display.text = generateInfo();
            Vector2 min = display.rectTransform.anchorMin;
            Vector2 max = display.rectTransform.anchorMax;
            float widthScale = display.preferredWidth / display.rectTransform.rect.width;
            float width = max.x - min.x;
            display.rectTransform.anchorMax = new Vector2(min.x + width * widthScale, max.y);
        }
    }

    public void OnModUnload()
    {
        if (imageContainer != null)
        {
            Destroy(imageContainer);
            imageContainer = null;
        }
        harmony.UnpatchAll(harmony.Id);
        Patch_raycast.ResetPositions();
        Log("Mod has been unloaded!");
    }

    private static JSONObject getSaveJson()
    {
        JSONObject data;
        try
        {
            data = new JSONObject(File.ReadAllText(configPath));
        }
        catch
        {
            data = JSONObject.Create();
            saveJson(data);
        }
        return data;
    }

    private static void saveJson(JSONObject data)
    {
        try
        {
            File.WriteAllText(configPath, data.ToString());
        }
        catch (Exception err)
        {
            Log("An error occured while trying to save settings: " + err.Message);
        }
    }
    public static void AddImageObject(Transform transform, float scale)
    {
        if (imageContainer == null)
        {
            OptionMenuContainer = settingsTraverse.Field("optionsCanvas").GetValue<GameObject>().transform.FindChildRecursively("OptionMenuParent").gameObject;
            GameObject backgroundImg = OptionMenuContainer.transform.FindChildRecursively("BrownBackground").gameObject;
            GameObject divider = OptionMenuContainer.transform.FindChildRecursively("Divider").gameObject;

            imageContainer = Instantiate(backgroundImg, transform, false);
            Image image = imageContainer.GetComponent<Image>();
            image.rectTransform.anchorMin = new Vector2(1f, 0.3f);
            image.rectTransform.anchorMax = new Vector2(1.2f, 0.7f);
            CreateText(imageContainer.transform, 0.5f, 0.825f, "Keybinds", canvas.dropText.fontSize, canvas.dropText.color, 1, 0.05f, canvas.dropText.font);
            Image newDiv = Instantiate(divider, imageContainer.transform, false).GetComponent<Image>();
            newDiv.rectTransform.anchorMin = new Vector2(0, 1.05f);
            newDiv.rectTransform.anchorMax = new Vector2(1, 1.05f);
            display = CreateText(imageContainer.transform, 0.2f, 0.1f, generateInfo(), canvas.dropText.fontSize, canvas.dropText.color, 1, 0.675f, canvas.dropText.font).GetComponent<Text>();
        }
    }
    public static string generateInfo()
    {
        string sprintName = MyInput.Keybinds["Sprint"].MainKey.ToShortString();
        bool altPressed = Input.GetKey(KeyCode.LeftAlt) || Input.GetKey(KeyCode.RightAlt);
        return "Hold <color=#FFFFFF>[" + sprintName + "]</color> + \n <color=#" + (overrideAccept ? "B0E0B0>-[Down]: Disable" : "E0B0B0>-[Up]: Enable") + " Force Accept</color>\n <color=#" + (overrideRayhit ? "B0E0B0>-[Right]: Disable" : "E0B0B0>-[Left]: Enable") + " Override Raycast</color>\n -<color=#FFFFFF>[Alt]</color>: Disable Both\n\nX Rotation: " + rotation.x + "\nZ Rotation: " + rotation.z + "\nHold <color=#FFFFFF>[" + MyInput.Keybinds["Rotate"].MainKey.ToShortString() + "] +</color>\n   -<color=#B0E0B0>[Left]</color><color=#E0B0B0>[Right]</color>: Rotate X by 90\n   -<color=#B0E0B0>[Up]</color><color=#E0B0B0>[Down]</color>: Rotate Z by 90\n\nHold <color=#FFFFFF>[Alt]</color>:\n <color=#" + (altPressed ? "B0E0B0" : "E0B0B0") + ">-Ignore permissions</color>\n <color=#" + ((altPressed && MyInput.GetButton("Sprint")) ? "B0E0B0" : "E0B0B0") + ">-[" + sprintName + "]: Ignore instability</color>";
    }

    public static GameObject CreateText(Transform canvas_transform, float x, float y, string text_to_print, int font_size, Color text_color, float width, float height, Font font, string name = "Text")
    {
        GameObject UItextGO = new GameObject("Text");
        UItextGO.transform.SetParent(canvas_transform, false);
        RectTransform trans = UItextGO.AddComponent<RectTransform>();
        trans.anchorMin = new Vector2(x, y);
        trans.anchorMax = trans.anchorMin + new Vector2(width, height);
        //trans.sizeDelta = new Vector2(width, height);
        //trans.anchoredPosition = new Vector2(x, y);
        Text text = UItextGO.AddComponent<Text>();
        text.text = text_to_print;
        text.font = font;
        text.fontSize = font_size;
        text.color = text_color;
        text.name = name;
        Shadow shadow = UItextGO.AddComponent<Shadow>();
        shadow.effectColor = new Color();
        return UItextGO;
    }
    public static void AddTextShadow(GameObject textObject, Color shadowColor, Vector2 shadowOffset)
    {
        Shadow shadow = textObject.AddComponent<Shadow>();
        shadow.effectColor = shadowColor;
        shadow.effectDistance = shadowOffset;
    }
    public static void CopyTextShadow(GameObject textObject, GameObject shadowSource)
    {
        Shadow sourcesShadow = shadowSource.GetComponent<Shadow>();
        if (sourcesShadow == null)
            sourcesShadow = shadowSource.GetComponentInChildren<Shadow>();
        AddTextShadow(textObject, sourcesShadow.effectColor, sourcesShadow.effectDistance);
    }

    public void ExtraSettingsAPI_Load()
    {
        togglePopupKey = ExtraSettingsAPI_GetKeybindName("Toggle Keybinds Popup");
    }
    public void ExtraSettingsAPI_SettingsClose()
    {
        overrideSupport = ExtraSettingsAPI_GetCheckboxState("No support override");
        fullOverride = ExtraSettingsAPI_GetComboboxSelectedIndex("Support Override Mode") == 1;
    }
    public void ExtraSettingsAPI_SettingsOpen()
    {
        ExtraSettingsAPI_SetCheckboxState("No support override", overrideSupport);
        ExtraSettingsAPI_SetComboboxSelectedIndex("Support Override Mode", fullOverride ? 1 : 0);
    }

    static Traverse ExtraSettingsAPI_Traverse;
    static bool ExtraSettingsAPI_Loaded = false;
    public bool ExtraSettingsAPI_GetCheckboxState(string SettingName)
    {
        if (ExtraSettingsAPI_Loaded)
            return ExtraSettingsAPI_Traverse.Method("getCheckboxState", new object[] { this, SettingName }).GetValue<bool>();
        return false;
    }
    public void ExtraSettingsAPI_SetCheckboxState(string SettingName, bool value)
    {
        if (ExtraSettingsAPI_Loaded)
            ExtraSettingsAPI_Traverse.Method("setCheckboxState", new object[] { this, SettingName, value }).GetValue();
    }
    public string ExtraSettingsAPI_GetKeybindName(string SettingName)
    {
        if (ExtraSettingsAPI_Loaded)
            return ExtraSettingsAPI_Traverse.Method("getKeybindName", new object[] { this, SettingName }).GetValue<string>();
        return "";
    }
    public void ExtraSettingsAPI_SetComboboxSelectedIndex(string SettingName, int value)
    {
        if (ExtraSettingsAPI_Loaded)
            ExtraSettingsAPI_Traverse.Method("setComboboxSelectedIndex", new object[] { this, SettingName, value }).GetValue();
    }
    public int ExtraSettingsAPI_GetComboboxSelectedIndex(string SettingName)
    {
        if (ExtraSettingsAPI_Loaded)
            return ExtraSettingsAPI_Traverse.Method("getComboboxSelectedIndex", new object[] { this, SettingName }).GetValue<int>();
        return -1;
    }
}

[HarmonyPatch(typeof(BlockQuad), "AcceptsBlock")]
public class Patch_accepter
{
    static void Postfix(ref BlockQuad __instance, ref Item_Base blockItem, ref bool __result)
    {
        if (StackablePlaceables.overrideAccept || (StackablePlaceables.overrideSupport && (Patch_raycast.NeedsSupport(__instance.ParentBlock) && blockItem != null && Patch_raycast.NeedsSupport(blockItem.settings_buildable.GetBlockPrefab(0)))))
            __result = true;
    }
}

[HarmonyPatch(typeof(BlockCreator), "GetQuadAtCursor")]
public class Patch_raycast
{
    static Dictionary<BlockQuad, Vector3> modifiedPositions = new Dictionary<BlockQuad, Vector3>();

    static void Prefix(ref BlockCreator __instance)
    {
        if (StackablePlaceables.overrideSupport && (!StackablePlaceables.overrideRayhit) && NeedsSupport(__instance.selectedBlock))
            UpdateNoSupport();
    }
    static void Postfix(ref BlockCreator __instance, ref BlockQuad __result)
    {
        if (StackablePlaceables.overrideRayhit)
        {
            RaycastHit raycastHit;
            if (__result != null && (Helper.HitAtCursor(out raycastHit, Player.UseDistance, LayerMasks.MASK_Item) || Helper.HitAtCursor(out raycastHit, Player.UseDistance, LayerMasks.MASK_RaycastInteractable)))
            {
                Add(__result);
                __result.transform.position = raycastHit.point;
            }
        }
        var quadSurface = Traverse.Create(__instance).Field<BlockSurface>("quadSurface");
        if (__result != null && quadSurface.Value == null)
        {
            quadSurface.Value = __result.GetSurfaceFromNormal(Vector3.down);
            if (quadSurface.Value == null && __result.acceptableBuildSides.Length > 0)
                quadSurface.Value = __result.acceptableBuildSides[0];
            if (quadSurface.Value == null)
                __result = null;
        }
    }
    public static void ResetPositions()
    {
        foreach (KeyValuePair<BlockQuad, Vector3> item in modifiedPositions)
            if (item.Key != null)
                item.Key.transform.localPosition = item.Value;
        modifiedPositions.Clear();
    }
    public static void UpdateNoSupport()
    {
        foreach (Block block in ComponentManager<Raft>.Value.GetComponentsInChildren<Block>())
        {
            if (NeedsSupport(block))
                foreach (BlockQuad quad in block.GetComponentsInChildren<BlockQuad>())
                    if (Mathf.Abs(quad.transform.localPosition.x) + Mathf.Abs(quad.transform.localPosition.z) == quad.transform.localPosition.magnitude && Add(quad))
                        quad.transform.localPosition = modifiedPositions[quad] * 2;
        }
    }
    public static bool Add(BlockQuad blockQuad)
    {
        return modifiedPositions.TryAdd(blockQuad, blockQuad.transform.localPosition);
    }

    public static bool NeedsSupport(Block block)
    {
        return block != null && block.buildableItem != null && block.IsWalkable() && !(block is Block_Foundation);
    }
}

[HarmonyPatch(typeof(BlockCreator), "SetGhostBlockPositionAndRotation")]
public class Patch_Rotation
{
    static void Postfix(ref BlockCreator __instance)
    {
        __instance.selectedBlock.transform.localEulerAngles += StackablePlaceables.rotation;
    }
}

[HarmonyPatch(typeof(BlockCreator), "SetBlockTypeToBuild", new Type[] { typeof(Item_Base) } )]
public class Patch_Deselect
{
    static bool p = false;
    static void Postfix(ref BlockCreator __instance)
    {
        if (Patch_raycast.NeedsSupport(__instance.selectedBlock) != p)
        {
            p = !p;
            Patch_raycast.ResetPositions();
        }
    }
}

[HarmonyPatch(typeof(BlockCreator), "SnapBuildRotation")]
public class Patch_CheckRotation
{
    static bool Prefix()
    {
        return false;
    }
}

[HarmonyPatch(typeof(Block), "IsStable")]
public class Patch_ForceStable
{
    static bool Prefix(ref Block __instance, ref bool __result)
    {
        if (StackablePlaceables.overrideSupport && (Patch_raycast.NeedsSupport(__instance) || StackablePlaceables.fullOverride))
        {
            __result = true;
            return false;
        }
        return true;
    }
}

[HarmonyPatch(typeof(BlockCreator), "CanBuildBlock")]
public class Patch_CheckBuildError
{
    static void Postfix(ref BlockCreator __instance, ref Block block, ref BuildError __result)
    {
        if ((Input.GetKey(KeyCode.LeftAlt) || Input.GetKey(KeyCode.RightAlt)) && (__result == BuildError.PositionOccupied || __result == BuildError.PositionOccupied_Same || __result == BuildError.InWater || (__result == BuildError.NotStable && MyInput.GetButton("Sprint"))))
            __result = __instance.HasEnoughResourcesToBuild(block) ? BuildError.None : BuildError.NoResources;
    }
}

public class timeDiff
{
    double value;
    public double maxTime;
    bool gradient;
    float progress
    {
        get
        {
            if (gradient)
                return (float)(0.5 - Math.Cos(Math.PI * value / maxTime) / 2);
            return (float)(value / maxTime);
        }
    }
    public timeDiff(double maxTime, bool useGradient = false, bool startAtMax = false)
    {
        this.maxTime = maxTime;
        gradient = useGradient;
        value = startAtMax ? maxTime : 0;
    }
    public float Update(bool toMax)
    {
        float timePassed = Time.deltaTime;
        value = Math.Min(maxTime, Math.Max(0, value + (toMax ? timePassed : -timePassed)));
        return progress;
    }
}
